if(!ETAGLIVE) var ETAGLIVE={};
if(!ETAGLIVE.tool) ETAGLIVE.tool={};
if(!ETAGLIVE.tool.TabControl) ETAGLIVE.tool.TabControl={};

ETAGLIVE.tool.TabControl = {
    contexts:new Array(),
    activeContext:null,
    collapsedRunning:false
}

with (ETAGLIVE.tool.TabControl) {
    ETAGLIVE.tool.TabControl.TabAdded = function(event)
    {
      var browser = event.target.linkedBrowser;
      var eToolbar = new ETAGLIVE.tool.TOOLBAR(createUniqueID());
      eToolbar.create(false);
      var context = new ETAGLIVE.tool.CONTEXT(eToolbar, browser)
      contexts.push(context);
    }

    ETAGLIVE.tool.TabControl.TabClosed = function(event)
    {
      var browser = event.target.linkedBrowser;
      var i = findBrowser(browser);
      if (i != -1)
      {
          context = contexts[i];
          contexts.splice(i, 1);
          context.toolbar.remove();
          context.remove();
          if (activeContext == context)
            activeContext = null;
      }
    }

    ETAGLIVE.tool.TabControl.TabSelected = function(event)
    {
      var browser = event.target.linkedBrowser;
      if (activeContext != null && activeContext.browser == browser)
        return;
      var previousToolbar = null;   
      var nextToolbar = null;
      if (activeContext != null)
      {
        previousToolbar = activeContext.toolbar;
        nextToolbar = previousToolbar.nextSibling;
        previousToolbar.makeShow(false);  
      }
      var i =findBrowser(browser);
      var context; 
      if (i == -1)
      {
        var eToolbar = new ETAGLIVE.tool.TOOLBAR(createUniqueID());
        eToolbar.create(true);
        context = new ETAGLIVE.tool.CONTEXT(eToolbar, browser);
        contexts.push(context);
      }
      else
      {
        context = contexts[i];
        context.toolbar.makeShow(true);
        if (nextToolbar)
            context.toolbar.move(nextToolbar);
      }
      activeContext = context;
    }

    ETAGLIVE.tool.TabControl.tabInitialize = function()
    {
        //create toolbar for the first Tab
        var eToolbar = new ETAGLIVE.tool.TOOLBAR(createUniqueID());
        eToolbar.create(true);
        
        var browser = gBrowser.selectedBrowser;
        var context = new ETAGLIVE.tool.CONTEXT(eToolbar, browser)
        
        contexts.push(context);
        activeContext = context;
        
        var container = gBrowser.tabContainer;
        container.addEventListener("TabOpen", TabAdded, false);
        container.addEventListener("TabClose", TabClosed, false);
        container.addEventListener("TabSelect", TabSelected, false);
    }    
    
    ETAGLIVE.tool.TabControl.setAllCollapsed = function(event)
    {
        
        if (event.attrName == "collapsed")
        {
            if (collapsedRunning)
                return;    
            collapsedRunning = true;
            var toolbar = event.currentTarget;
            for (var i=0; i< contexts.length; i++)
            {
                var context = contexts[i];
                context.toolbar.toolbar.collapsed = toolbar.collapsed;
            }
            ETAGLIVE.tool.utils.setPrefBool("collapsed", toolbar.collapsed);
            collapsedRunning = false    
        }
        
    }

    ETAGLIVE.tool.TabControl.getCollapsedCached = function()
    {
        if (!ETAGLIVE.tool.utils.isHasPrefValue("collapsed"))
            return false;
        else
            return ETAGLIVE.tool.utils.getPrefBool("collapsed");    
    }

    ETAGLIVE.tool.TabControl.createUniqueID = function()
    {
        return Math.floor(Math.random() * 65536);
    }

    ETAGLIVE.tool.TabControl.findBrowser = function(browser)
    {
        for (var i=0; i< contexts.length; i++)
        {
            var context = contexts[i];
            if (context.browser == browser)
            {
                return i;
            }
        }
        return -1;
    }

    ETAGLIVE.tool.TabControl.findContext = function(doc)
    {
        for (var i=0; i< contexts.length; i++)
        {
            var context = contexts[i];
            if (context.browser.contentDocument == doc)
            {
                return context;
            }
        }
        return null;
    }
}