if(!ETAGLIVE) var ETAGLIVE={};
if(!ETAGLIVE.tool) ETAGLIVE.tool={};
ETAGLIVE.tool.TOOLBAR = function (uid,context)
{
    this.uid = uid;
    this.toolbar = null;
    this.context = null;
    ETAGLIVE.tool.main.toolbox = document.getElementById("navigator-toolbox");
    this.notification = null;
    this.menu = null;
}

ETAGLIVE.tool.TOOLBAR.prototype.create = function(show)
{
    this.createToolbarEle(show); 
    var logobutton =  document.createElement("toolbarbutton");  
    logobutton.id=this.prefix("eTagLive-logo"); 
    logobutton.setAttribute("tooltiptext","Go to eTagLive.com");
    logobutton.setAttribute("image","chrome://etaglive/skin/toolbar/logo.gif");
    logobutton.setAttribute("type","menu-button");
    logobutton.setAttribute("oncommand","ETAGLIVE.tool.main.LogoClicked()");
    logobutton.style.maxHeight = ETAGLIVE.tool.main.buttonHeight;
    logobutton.style.paddingTop = "0px";
    logobutton.style.paddingBottom = "0px";
    this.toolbar.appendChild(logobutton);
    //set listener
    this.toolbar.addEventListener("DOMAttrModified", ETAGLIVE.tool.TabControl.setAllCollapsed, false);
    //create menu
    this.createMenu();
    logobutton.appendChild(this.menu);
    //check login and add menu
    if(!ETAGLIVE.tool.main.isLogin)
    {
        if (ETAGLIVE.tool.utils.getPrefString("ClientID") != "" && ETAGLIVE.tool.utils.getPrefString("RequestCookie") != "")
        {
            ETAGLIVE.tool.main.loginStruct.ClientID =  ETAGLIVE.tool.utils.getPrefString("ClientID");
            ETAGLIVE.tool.main.loginStruct.RequestCookies =  ETAGLIVE.tool.utils.getPrefString("RequestCookie");
            ETAGLIVE.tool.main.loginStruct.iRemember = true;
            this.createAutoLogin();
            return;
        }
    }
    
    this.toolbar.style.fontSize = "14px";
    this.createMenuToolbar();
}

ETAGLIVE.tool.TOOLBAR.prototype.createAutoLogin = function()
{
    //create button auto login
    var button =  document.createElement("toolbarbutton");  
    button.id=this.prefix("eTagLive-AutoLogin"); 
    button.setAttribute("label","Login....");
    button.style.maxHeight = ETAGLIVE.tool.main.buttonHeight;
    button.style.paddingTop = "0px";
    button.style.paddingBottom = "0px";
    this.toolbar.appendChild(button);
    //menu
    var obj = document.getElementById(this.prefix("eTagLive-LogInOut"));
    obj.setAttribute("disabled", true);
    window.setTimeout(ETAGLIVE.tool.main.autoLogon, 5000);
    
}

ETAGLIVE.tool.TOOLBAR.prototype.createMenuToolbar = function()
{
    var disableButtons = false;
    if (!ETAGLIVE.tool.main.isLogin && !ETAGLIVE.tool.utils.isHasPrefValue("EnabledFirst"))
        disableButtons = true;
    else
        ETAGLIVE.tool.utils.setPrefBool("EnabledFirst", true);    
    //create buttons on Menu
    var button =  document.createElement("toolbarbutton");  
    button.id=this.prefix("eTagLive-AreaSave"); 
    button.setAttribute("tooltiptext","Pick e-Clips/Images");
    button.setAttribute("image","chrome://etaglive/skin/toolbar/area.gif");
    //button.parentToolbar = this;
    button.style.paddingRight = "0px";
    button.style.maxHeight = ETAGLIVE.tool.main.buttonHeight;
    button.style.paddingTop = "0px";
    button.style.paddingBottom = "0px";
    button.setAttribute("oncommand", "ETAGLIVE.tool.operation.save(ETAGLIVE.tool.operation.SAVEBLOCK)");
    this.toolbar.appendChild(button);
    
    button =  document.createElement("toolbarbutton");  
    button.id=this.prefix("eTagLive-BookmarkSave"); 
    button.setAttribute("tooltiptext","Bookmark");
    if (disableButtons)
    {
        button.setAttribute("disabled", true);
        button.setAttribute("image","chrome://etaglive/skin/toolbar/dis_bookmark.gif");
    }
    else
        button.setAttribute("image","chrome://etaglive/skin/toolbar/bookmark.gif");
    //button.parentToolbar = this;
    button.style.paddingRight = "0px";
    button.style.maxHeight = ETAGLIVE.tool.main.buttonHeight;
    button.style.paddingTop = "0px";
    button.style.paddingBottom = "0px";
    button.setAttribute("oncommand", "ETAGLIVE.tool.operation.save(ETAGLIVE.tool.operation.SAVEBOOKMARK)");
    
    this.toolbar.appendChild(button);
    
    button =  document.createElement("toolbarbutton");  
    button.id=this.prefix("eTagLive-NotepadSave"); 
    button.setAttribute("tooltiptext","NotePad");
    if (disableButtons)
    {
        button.setAttribute("disabled", true);
        button.setAttribute("image","chrome://etaglive/skin/toolbar/dis_text.gif");
    }
    else
        button.setAttribute("image","chrome://etaglive/skin/toolbar/text.gif");
    //button.parentToolbar = this;
    button.style.paddingRight = "0px";
    button.style.maxHeight = ETAGLIVE.tool.main.buttonHeight;
    button.style.paddingTop = "0px";
    button.style.paddingBottom = "0px";
    button.setAttribute("oncommand", "ETAGLIVE.tool.operation.save(ETAGLIVE.tool.operation.SAVETEXT)");
    button.setAttribute("disabled", disableButtons);
    this.toolbar.appendChild(button);
    
    button =  document.createElement("toolbarseparator");
    button.id=this.prefix("eTagLive-ToolbarSeparator-1"); 
    this.toolbar.appendChild(button);
    
    button =  document.createElement("toolbarbutton");  
    button.id=this.prefix("eTagLive-MyItems"); 
    if (disableButtons)
    {
        button.setAttribute("disabled", true);
        button.setAttribute("image","chrome://etaglive/skin/toolbar/dis_mysavedi.gif");
    }
    else
        button.setAttribute("image","chrome://etaglive/skin/toolbar/mysavedi.gif");
    //button.parentToolbar = this;
    button.style.paddingRight = "0px";
    button.style.maxHeight = ETAGLIVE.tool.main.buttonHeight;
    button.style.paddingTop = "0px";
    button.style.paddingBottom = "0px";
    button.setAttribute("oncommand", "ETAGLIVE.tool.operation.mySavedItems()");
    button.setAttribute("disabled", disableButtons);
    this.toolbar.appendChild(button);
}

ETAGLIVE.tool.TOOLBAR.prototype.createSelectionBar = function()
{
    this.destroyAllButtons();
    
    var button =  document.createElement("toolbarbutton");  
    button.id=this.prefix("eTagLive-LabelItBtn"); 
    button.setAttribute("label","Ok/Continue");
    button.setAttribute("image","chrome://etaglive/skin/toolbar/okcontinue.gif");
    button.setAttribute("oncommand", "ETAGLIVE.tool.operation.labelIt()");
    button.style.maxHeight = ETAGLIVE.tool.main.buttonHeight;
    button.style.paddingTop = "0px";
    button.style.paddingBottom = "0px";
    this.toolbar.appendChild(button);
    
    button =  document.createElement("toolbarbutton");  
    button.id=this.prefix("eTagLive-CancelBtn"); 
    button.setAttribute("label","Cancel");
    button.setAttribute("image","chrome://etaglive/skin/toolbar/cancel1.gif");
    button.setAttribute("oncommand", "ETAGLIVE.tool.operation.Cancel()");
    button.style.maxHeight = ETAGLIVE.tool.main.buttonHeight;
    button.style.paddingTop = "0px";
    button.style.paddingBottom = "0px";
    this.toolbar.appendChild(button);
    
    button =  document.createElement("toolbarseparator");
    this.toolbar.appendChild(button);
    
    this.context.nUnitsSelected = 0;
    var desc = document.createElement("description");
    desc.id=this.prefix("eTagLive_numberSelection");
    desc.setAttribute("value","   0 area(s) selected.");
    desc.style.fontFamily = "Times New Roman";
    desc.style.color = "#880000";
    desc.style.paddingTop = "6px";
    this.toolbar.appendChild(desc);
}

ETAGLIVE.tool.TOOLBAR.prototype.destroyAllButtons = function()
{
    
    while(this.toolbar.childNodes.length > 1)    
    {
        var obj = this.toolbar.lastChild;
        this.toolbar.removeChild(obj);
    }
}

ETAGLIVE.tool.TOOLBAR.prototype.destroySelectionToolbar = function()
{
    if (document.getElementById(this.prefix("eTagLive-LabelItBtn"))!= null )
    {
        this.destroyAllButtons();
        this.context.sNodesSelected = "";
        this.context.arrNodeSelected = new Array();
        this.context.mapNodeAddedName = new Array();
        this.createMenuToolbar();
        //this.context.idMenuSelecting = 0;
        var tabbrowser = document.getElementById("content");
        if (this.notification.parentNode)
        {
            var notificationbox = tabbrowser.getNotificationBox(this.context.browser);
            notificationbox.removeNotification(this.notification);
        }    
        this.notification = null;
    }
}

ETAGLIVE.tool.TOOLBAR.prototype.createToolbarEle = function(show)
{
    this.toolbar = document.createElement("toolbar");
    this.toolbar.id = this.prefix("eTagLive-toolbar"); 
    this.toolbar.className = "chromeclass-toolbar";
    this.toolbar.persist="collapsed,hidden";
    this.toolbar.setAttribute("collapsed",ETAGLIVE.tool.TabControl.getCollapsedCached()); 
    this.toolbar.setAttribute("context","toolbar-context-menu"); 
    this.toolbar.setAttribute("height",(navigator.userAgent.indexOf("Firefox/2.") == -1?"30px":"28px")); 
    this.toolbar.setAttribute("customizable",false); 
    this.toolbar.setAttribute("mode","full");
    this.makeShow(show);
    ETAGLIVE.tool.main.toolbox.appendChild(this.toolbar);
}

ETAGLIVE.tool.TOOLBAR.prototype.createMenu= function()
{
    this.menu = document.createElement("menupopup");
    // add GoHome button
    var menuitem = document.createElement("menuitem");
    menuitem.id = this.prefix("eTagLive-GoHome");
    menuitem.className = "menuitem-iconic";
    menuitem.setAttribute("label","Go Home");
    menuitem.setAttribute("image","chrome://etaglive/skin/toolbar/GoHome.ico");
    menuitem.setAttribute("oncommand","ETAGLIVE.tool.main.GoHome(event)");
    this.menu.appendChild(menuitem);
    //add Replace Temporary Account
    menuitem = document.createElement("menuitem");
    menuitem.id = this.prefix("eTagLive-ReplaceTemp");
    menuitem.className = "menuitem-iconic";
    menuitem.setAttribute("label","Replace Temp Account");
    menuitem.setAttribute("image","chrome://etaglive/skin/toolbar/TempAccount.ico");
    menuitem.setAttribute("oncommand","ETAGLIVE.tool.main.ReplaceTempAccount(event)");
    menuitem.setAttribute("hidden",true);    
    this.menu.appendChild(menuitem);
    //add Log in or log out button
    if (ETAGLIVE.tool.main.isLogin)
    {
        // creating logout menu
        menuitem = document.createElement("menuitem");
        menuitem.id = this.prefix("eTagLive-LogInOut");
        menuitem.className = "menuitem-iconic";
        menuitem.setAttribute("label","Log Out");
        menuitem.setAttribute("image","chrome://etaglive/skin/toolbar/LogOut.ico");
        menuitem.setAttribute("oncommand","ETAGLIVE.tool.main.LogOut(event)");
        this.menu.appendChild(menuitem);
    }
    else
    {
        menuitem = document.createElement("menuitem");
        menuitem.id = this.prefix("eTagLive-LogInOut");
        menuitem.className = "menuitem-iconic";
        menuitem.setAttribute("label","Log In");
        menuitem.setAttribute("image","chrome://etaglive/skin/toolbar/LogIn.ico");
        menuitem.setAttribute("oncommand","ETAGLIVE.tool.main.LogIn(event)");
        this.menu.appendChild(menuitem);
    }
}

ETAGLIVE.tool.TOOLBAR.prototype.makeShow = function(isShow)
{
    if (isShow)
    {
        this.toolbar.setAttribute("hidden",false); 
        this.toolbar.setAttribute("toolbarname","eTag Web Capture"); 
    }
    else
    {
        this.toolbar.setAttribute("hidden",true); 
        this.toolbar.setAttribute("toolbarname",""); 
    }
}

ETAGLIVE.tool.TOOLBAR.prototype.prefix = function(strSource)
{
    return (strSource + "-n" + this.uid);
}

ETAGLIVE.tool.TOOLBAR.prototype.move = function(toolbarafter)
{
    ETAGLIVE.tool.main.toolbox.insertBefore(this.toolbar, toolbarafter);
}

ETAGLIVE.tool.TOOLBAR.prototype.remove = function()
{
    this.toolbar.removeEventListener("DOMAttrModified", ETAGLIVE.tool.TabControl.setAllCollapsed, false);
    ETAGLIVE.tool.main.toolbox.removeChild(this.toolbar);
    this.toolbar = null;
}

ETAGLIVE.tool.TOOLBAR.prototype.showSelectionNumbers = function(number)
{
    this.context.nUnitsSelected += number;
    var oDesc = document.getElementById(this.prefix("eTagLive_numberSelection"));   
    oDesc.setAttribute("value","   " + this.context.nUnitsSelected + " area(s) selected.");
}